diff --git a/src/libs/zbxdbcache/dbconfig.c b/src/libs/zbxdbcache/dbconfig.c
index ffe05ba..1f65542 100644
--- a/src/libs/zbxdbcache/dbconfig.c
+++ b/src/libs/zbxdbcache/dbconfig.c
@@ -288,8 +288,6 @@ static zbx_uint64_t	get_item_nextcheck_seed(zbx_uint64_t itemid, zbx_uint64_t in
 	return itemid;
 }
 
-static int	DCget_disable_until(const ZBX_DC_ITEM *item, const ZBX_DC_HOST *host);
-
 #define ZBX_ITEM_COLLECTED		0x01	/* force item rescheduling after new value collection */
 #define ZBX_HOST_UNREACHABLE		0x02
 #define ZBX_ITEM_KEY_CHANGED		0x04
@@ -410,62 +408,6 @@ static void	DCitem_poller_type_update(ZBX_DC_ITEM *dc_item, const ZBX_DC_HOST *d
 	}
 }
 
-static int	DCget_disable_until(const ZBX_DC_ITEM *item, const ZBX_DC_HOST *host)
-{
-	switch (item->type)
-	{
-		case ITEM_TYPE_ZABBIX:
-			if (0 != host->errors_from)
-				return host->disable_until;
-			break;
-		case ITEM_TYPE_SNMPv1:
-		case ITEM_TYPE_SNMPv2c:
-		case ITEM_TYPE_SNMPv3:
-			if (0 != host->snmp_errors_from)
-				return host->snmp_disable_until;
-			break;
-		case ITEM_TYPE_IPMI:
-			if (0 != host->ipmi_errors_from)
-				return host->ipmi_disable_until;
-			break;
-		case ITEM_TYPE_JMX:
-			if (0 != host->jmx_errors_from)
-				return host->jmx_disable_until;
-			break;
-		default:
-			/* nothing to do */;
-	}
-
-	return 0;
-}
-
-static void	DCincrease_disable_until(const ZBX_DC_ITEM *item, ZBX_DC_HOST *host, int now)
-{
-	switch (item->type)
-	{
-		case ITEM_TYPE_ZABBIX:
-			if (0 != host->errors_from)
-				host->disable_until = now + CONFIG_TIMEOUT;
-			break;
-		case ITEM_TYPE_SNMPv1:
-		case ITEM_TYPE_SNMPv2c:
-		case ITEM_TYPE_SNMPv3:
-			if (0 != host->snmp_errors_from)
-				host->snmp_disable_until = now + CONFIG_TIMEOUT;
-			break;
-		case ITEM_TYPE_IPMI:
-			if (0 != host->ipmi_errors_from)
-				host->ipmi_disable_until = now + CONFIG_TIMEOUT;
-			break;
-		case ITEM_TYPE_JMX:
-			if (0 != host->jmx_errors_from)
-				host->jmx_disable_until = now + CONFIG_TIMEOUT;
-			break;
-		default:
-			/* nothing to do */;
-	}
-}
-
 /******************************************************************************
  *                                                                            *
  * Function: DCfind_id                                                        *
@@ -1012,7 +954,7 @@ static void	DCsync_hosts(zbx_dbsync_t *sync)
 
 		ZBX_STR2UINT64(hostid, row[0]);
 		ZBX_DBROW2UINT64(proxy_hostid, row[1]);
-		ZBX_STR2UCHAR(status, row[22]);
+		ZBX_STR2UCHAR(status, row[14]);
 
 		host = (ZBX_DC_HOST *)DCfind_id(&config->hosts, hostid, sizeof(ZBX_DC_HOST), &found);
 
@@ -1071,10 +1013,10 @@ static void	DCsync_hosts(zbx_dbsync_t *sync)
 		/* store new information in host structure */
 
 		DCstrpool_replace(found, &host->host, row[2]);
-		DCstrpool_replace(found, &host->name, row[23]);
+		DCstrpool_replace(found, &host->name, row[15]);
 #if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
-		DCstrpool_replace(found, &host->tls_issuer, row[31]);
-		DCstrpool_replace(found, &host->tls_subject, row[32]);
+		DCstrpool_replace(found, &host->tls_issuer, row[23]);
+		DCstrpool_replace(found, &host->tls_subject, row[24]);
 
 		/* maintain 'config->psks' in configuration cache */
 
@@ -1143,7 +1085,7 @@ static void	DCsync_hosts(zbx_dbsync_t *sync)
 
 		psk_owner = NULL;
 
-		if ('\0' == *row[33] || '\0' == *row[34])	/* new PSKid or value empty */
+		if ('\0' == *row[25] || '\0' == *row[26])	/* new PSKid or value empty */
 		{
 			/* In case of "impossible" errors ("PSK value without identity" or "PSK identity without */
 			/* value") assume empty PSK identity and value. These errors should have been prevented */
@@ -1174,14 +1116,14 @@ static void	DCsync_hosts(zbx_dbsync_t *sync)
 
 		/* new PSKid and value non-empty */
 
-		zbx_strlower(row[34]);
+		zbx_strlower(row[26]);
 
 		if (1 == found && NULL != host->tls_dc_psk)	/* 'host' record has non-empty PSK */
 		{
-			if (0 == strcmp(host->tls_dc_psk->tls_psk_identity, row[33]))	/* new PSKid same as */
+			if (0 == strcmp(host->tls_dc_psk->tls_psk_identity, row[25]))	/* new PSKid same as */
 											/* old PSKid */
 			{
-				if (0 != strcmp(host->tls_dc_psk->tls_psk, row[34]))	/* new PSK value */
+				if (0 != strcmp(host->tls_dc_psk->tls_psk, row[26]))	/* new PSK value */
 											/* differs from old */
 				{
 					if (NULL == (psk_owner = (zbx_ptr_pair_t *)zbx_hashset_search(&psk_owners,
@@ -1218,17 +1160,17 @@ static void	DCsync_hosts(zbx_dbsync_t *sync)
 
 		/* new PSK identity already stored? */
 
-		psk_i_local.tls_psk_identity = row[33];
+		psk_i_local.tls_psk_identity = row[25];
 
 		if (NULL != (psk_i = (ZBX_DC_PSK *)zbx_hashset_search(&config->psks, &psk_i_local)))
 		{
 			/* new PSKid already in psks hashset */
 
-			if (0 != strcmp(psk_i->tls_psk, row[34]))	/* PSKid stored but PSK value is different */
+			if (0 != strcmp(psk_i->tls_psk, row[26]))	/* PSKid stored but PSK value is different */
 			{
 				if (NULL == (psk_owner = (zbx_ptr_pair_t *)zbx_hashset_search(&psk_owners, &psk_i->tls_psk_identity)))
 				{
-					DCstrpool_replace(1, &psk_i->tls_psk, row[34]);
+					DCstrpool_replace(1, &psk_i->tls_psk, row[26]);
 				}
 				else
 				{
@@ -1245,8 +1187,8 @@ static void	DCsync_hosts(zbx_dbsync_t *sync)
 
 		/* insert new PSKid and value into psks hashset */
 
-		DCstrpool_replace(0, &psk_i_local.tls_psk_identity, row[33]);
-		DCstrpool_replace(0, &psk_i_local.tls_psk, row[34]);
+		DCstrpool_replace(0, &psk_i_local.tls_psk_identity, row[25]);
+		DCstrpool_replace(0, &psk_i_local.tls_psk, row[26]);
 		psk_i_local.refcount = 1;
 		host->tls_dc_psk = zbx_hashset_insert(&config->psks, &psk_i_local, sizeof(ZBX_DC_PSK));
 done:
@@ -1263,8 +1205,8 @@ done:
 			}
 		}
 #endif
-		ZBX_STR2UCHAR(host->tls_connect, row[29]);
-		ZBX_STR2UCHAR(host->tls_accept, row[30]);
+		ZBX_STR2UCHAR(host->tls_connect, row[21]);
+		ZBX_STR2UCHAR(host->tls_accept, row[22]);
 
 		if (0 == found)
 		{
@@ -1274,32 +1216,21 @@ done:
 			host->data_expected_from = now;
 			host->update_items = 0;
 
-			host->errors_from = atoi(row[10]);
 			host->available = (unsigned char)atoi(row[11]);
-			host->disable_until = atoi(row[12]);
-			host->snmp_errors_from = atoi(row[13]);
-			host->snmp_available = (unsigned char)atoi(row[14]);
-			host->snmp_disable_until = atoi(row[15]);
-			host->ipmi_errors_from = atoi(row[16]);
-			host->ipmi_available = (unsigned char)atoi(row[17]);
-			host->ipmi_disable_until = atoi(row[18]);
-			host->jmx_errors_from = atoi(row[19]);
-			host->jmx_available = (unsigned char)atoi(row[20]);
-			host->jmx_disable_until = atoi(row[21]);
-			host->availability_ts = now;
-
-			DCstrpool_replace(0, &host->error, row[25]);
-			DCstrpool_replace(0, &host->snmp_error, row[26]);
-			DCstrpool_replace(0, &host->ipmi_error, row[27]);
-			DCstrpool_replace(0, &host->jmx_error, row[28]);
+			host->snmp_available = (unsigned char)atoi(row[12]);
+			host->ipmi_available = (unsigned char)atoi(row[13]);
+			host->jmx_available = (unsigned char)atoi(row[14]);
+
+			DCstrpool_replace(0, &host->error, row[17]);
+			DCstrpool_replace(0, &host->snmp_error, row[18]);
+			DCstrpool_replace(0, &host->ipmi_error, row[19]);
+			DCstrpool_replace(0, &host->jmx_error, row[20]);
 
 			host->items_num = 0;
 			host->snmp_items_num = 0;
 			host->ipmi_items_num = 0;
 			host->jmx_items_num = 0;
 
-			host->reset_availability = 0;
-
 			zbx_vector_ptr_create_ext(&host->interfaces_v, __config_mem_malloc_func,
 					__config_mem_realloc_func, __config_mem_free_func);
 		}
@@ -1307,10 +1238,6 @@ done:
 		{
 			if (HOST_STATUS_MONITORED == status && HOST_STATUS_MONITORED != host->status)
 				host->data_expected_from = now;
-
-			/* reset host status if host proxy assignment has been changed */
-			if (proxy_hostid != host->proxy_hostid)
-				host->reset_availability = 1;
 		}
 
 		host->proxy_hostid = proxy_hostid;
@@ -1367,12 +1294,12 @@ done:
 				proxy->timediff = 0;
 				proxy->location = ZBX_LOC_NOWHERE;
 				proxy->version = 0;
-				proxy->lastaccess = atoi(row[24]);
+				proxy->lastaccess = atoi(row[16]);
 				proxy->last_cfg_error_time = 0;
 			}
 
-			proxy->auto_compress = atoi(row[32 + ZBX_HOST_TLS_OFFSET]);
-			DCstrpool_replace(found, &proxy->proxy_address, row[31 + ZBX_HOST_TLS_OFFSET]);
+			proxy->auto_compress = atoi(row[24 + ZBX_HOST_TLS_OFFSET]);
+			DCstrpool_replace(found, &proxy->proxy_address, row[23 + ZBX_HOST_TLS_OFFSET]);
 
 			if (HOST_STATUS_PROXY_PASSIVE == status && (0 == found || status != host->status))
 			{
@@ -2257,7 +2184,140 @@ static void	dc_host_update_agent_stats(ZBX_DC_HOST *host, unsigned char type, in
 	}
 }
 
-static void	DCsync_items(zbx_dbsync_t *sync, int flags)
+static void	DCincrease_disable_until(const ZBX_DC_ITEM *item, int now)
+{
+	if (NULL == item->ifstatus)
+		return;
+
+	if (0 != item->ifstatus->agent.errors_from)
+	{
+		item->ifstatus->agent.disable_until = now + CONFIG_TIMEOUT;
+		zbx_hashset_insert(&config->hosts_availability, &item->hostid, sizeof(item->hostid));
+	}
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: ifstatus_compare_func                                            *
+ *                                                                            *
+ * Purpose: comparison function for zbx_dc_ifstatus_t pointer vector          *
+ *                                                                            *
+ ******************************************************************************/
+static int	ifstatus_compare_func(const void *d1, const void *d2)
+{
+	const zbx_dc_ifstatus_t	*if1 = *(const zbx_dc_ifstatus_t **)d1;
+	const zbx_dc_ifstatus_t	*if2 = *(const zbx_dc_ifstatus_t **)d2;
+
+	ZBX_RETURN_IF_NOT_EQUAL(if1->interfaceid, if2->interfaceid);
+	ZBX_RETURN_IF_NOT_EQUAL(if1->agent_hash, if2->agent_hash);
+	return 0;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: dc_host_ifstatus_add                                             *
+ *                                                                            *
+ * Purpose: adds interface status to host interface status vector             *
+ *                                                                            *
+ * Parameters: hostid      - [IN] the host identifier                         *
+ *             interfaceid - [IN] the interface identifier                    *
+ *             agent_type  - [IN] the interface type                          *
+ *             agent_hash  - [IN] the hash sum of custom agent parameters     *
+ *             available   - [IN] the initial availability for new statuses   *
+ *                                                                            *
+ * Return value: The created or updated interface status object.              *
+ *                                                                            *
+ ******************************************************************************/
+static zbx_dc_ifstatus_t	*dc_host_ifstatus_add(zbx_uint64_t hostid, zbx_uint64_t interfaceid,
+		unsigned char agent_type, zbx_hash_t agent_hash, unsigned char available)
+{
+	zbx_dc_host_ifstatus_t	*hostif;
+	zbx_dc_ifstatus_t	*ifstatus;
+	int			index;
+
+	if (NULL == (hostif = (zbx_dc_host_ifstatus_t *)zbx_hashset_search(&config->hosts_ifstatus, &hostid)))
+	{
+		zbx_dc_host_ifstatus_t	hostif_local;
+
+		hostif_local.hostid = hostid;
+		hostif = zbx_hashset_insert(&config->hosts_ifstatus, &hostif_local, sizeof(hostif_local));
+		zbx_vector_ptr_create_ext(&hostif->ifs, __config_mem_malloc_func, __config_mem_realloc_func,
+				__config_mem_free_func);
+		index = FAIL;
+	}
+	else
+	{
+		zbx_dc_ifstatus_t	ifstatus_local;
+
+		ifstatus_local.interfaceid = interfaceid;
+		ifstatus_local.agent_hash = agent_hash;
+
+		index = zbx_vector_ptr_search(&hostif->ifs, &ifstatus_local, ifstatus_compare_func);
+	}
+
+	if (FAIL == index)
+	{
+		ifstatus = (zbx_dc_ifstatus_t *)__config_mem_malloc_func(NULL, sizeof(zbx_dc_ifstatus_t));
+		ifstatus->interfaceid = interfaceid;
+		ifstatus->agent_hash = agent_hash;
+		ifstatus->refcount = 1;
+		ifstatus->agent.available = available;
+		ifstatus->agent.disable_until = 0;
+		ifstatus->agent.errors_from = 0;
+		ifstatus->agent.error = (char *)zbx_strpool_intern("");
+		ifstatus->type = agent_type;
+		zbx_vector_ptr_append(&hostif->ifs, ifstatus);
+
+		zbx_hashset_insert(&config->hosts_availability, &hostid, sizeof(hostid));
+
+		return ifstatus;
+
+	}
+
+	ifstatus = hostif->ifs.values[index];
+	ifstatus->refcount++;
+
+	return ifstatus;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: dc_host_ifstatus_release                                         *
+ *                                                                            *
+ * Purpose: releases interface status, freeing resources as necessary         *
+ *                                                                            *
+ * Parameters: hostid   - [IN] the host identifier                            *
+ *             ifstatus - [IN] the interface status object                    *
+ *                                                                            *
+ ******************************************************************************/
+static void	dc_host_ifstatus_release(zbx_uint64_t hostid, zbx_dc_ifstatus_t *ifstatus)
+{
+	zbx_dc_host_ifstatus_t	*hostif;
+
+	if (0 != --ifstatus->refcount)
+		return;
+	if (NULL != (hostif = (zbx_dc_host_ifstatus_t *)zbx_hashset_search(&config->hosts_ifstatus, &hostid)))
+	{
+		int	index;
+
+		if (FAIL != (index = zbx_vector_ptr_search(&hostif->ifs, ifstatus, ZBX_DEFAULT_PTR_COMPARE_FUNC)))
+		{
+			zbx_vector_ptr_remove_noorder(&hostif->ifs, index);
+			if (0 == hostif->ifs.values_num)
+			{
+				zbx_vector_ptr_destroy(&hostif->ifs);
+				zbx_hashset_remove_direct(&config->hosts_ifstatus, hostif);
+			}
+
+			zbx_hashset_insert(&config->hosts_availability, &hostid, sizeof(hostid));
+		}
+	}
+
+	zbx_strpool_release(ifstatus->agent.error);
+	__config_mem_free_func(ifstatus);
+}
+
+static void	DCsync_items(zbx_dbsync_t *sync, int flags, unsigned char mode)
 {
 	const char		*__function_name = "DCsync_items";
 
@@ -2287,10 +2347,11 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 	ZBX_DC_ITEM_HK		*item_hk, item_hk_local;
 
 	time_t			now;
-	unsigned char		status, type, value_type, old_poller_type;
+	unsigned char		status, type, value_type, old_poller_type, agent_type;
 	int			found, update_index, ret, i,  old_nextcheck;
-	zbx_uint64_t		itemid, hostid;
+	zbx_uint64_t		itemid, hostid, old_interfaceid, agent_interfaceid;
 	zbx_vector_ptr_t	dep_items;
+	zbx_hash_t		agent_hash, old_agent_hash;
 
 	zbx_vector_ptr_create(&dep_items);
 
@@ -2300,6 +2361,9 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 
 	while (SUCCEED == (ret = zbx_dbsync_next(sync, &rowid, &row, &tag)))
 	{
+		agent_hash = 0;
+		agent_type = ZBX_AGENT_UNKNOWN;
+
 		/* removed rows will be always added at the end */
 		if (ZBX_DBSYNC_ROW_REMOVE == tag)
 			break;
@@ -2353,7 +2417,6 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 		item->hostid = hostid;
 		DCstrpool_replace(found, &item->port, row[8]);
 		item->flags = (unsigned char)atoi(row[24]);
-		ZBX_DBROW2UINT64(item->interfaceid, row[25]);
 
 		if (ZBX_HK_OPTION_ENABLED == config->config->hk.history_global)
 		{
@@ -2392,9 +2455,13 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 			item->poller_type = ZBX_NO_POLLER;
 			item->queue_priority = ZBX_QUEUE_PRIORITY_NORMAL;
 			item->schedulable = 1;
+			item->ifstatus = NULL;
+			old_interfaceid = 0;
 		}
 		else
 		{
+			old_interfaceid = item->interfaceid;
+
 			if (item->type != type)
 				flags |= ZBX_ITEM_TYPE_CHANGED;
 
@@ -2405,6 +2472,9 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 				dc_host_update_agent_stats(host, item->type, -1);
 		}
 
+		ZBX_DBROW2UINT64(item->interfaceid, row[25]);
+
+
 		if (ITEM_STATUS_ACTIVE == status)
 			dc_host_update_agent_stats(host, type, 1);
 
@@ -2473,6 +2543,10 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 				else
 					snmpitem->snmp_oid_type = ZBX_SNMP_OID_TYPE_NORMAL;
 			}
+
+			agent_hash = ZBX_DEFAULT_STRING_HASH_FUNC(snmpitem->snmpv3_contextname);
+			agent_hash = ZBX_DEFAULT_STRING_HASH_ALGO(item->port, strlen(item->port), agent_hash);
+			agent_type = ZBX_AGENT_SNMP;
 		}
 		else if (NULL != (snmpitem = (ZBX_DC_SNMPITEM *)zbx_hashset_search(&config->snmpitems, &itemid)))
 		{
@@ -2495,6 +2569,9 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 			ipmiitem = (ZBX_DC_IPMIITEM *)DCfind_id(&config->ipmiitems, itemid, sizeof(ZBX_DC_IPMIITEM), &found);
 
 			DCstrpool_replace(found, &ipmiitem->ipmi_sensor, row[13]);
+
+			agent_hash = 0;
+			agent_type = ZBX_AGENT_IPMI;
 		}
 		else if (NULL != (ipmiitem = (ZBX_DC_IPMIITEM *)zbx_hashset_search(&config->ipmiitems, &itemid)))
 		{
@@ -2649,6 +2726,10 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 			DCstrpool_replace(found, &jmxitem->username, row[20]);
 			DCstrpool_replace(found, &jmxitem->password, row[21]);
 			DCstrpool_replace(found, &jmxitem->jmx_endpoint, row[37]);
+
+			agent_hash = ZBX_DEFAULT_STRING_HASH_FUNC(jmxitem->jmx_endpoint);
+
+			agent_type = ZBX_AGENT_JMX;
 		}
 		else if (NULL != (jmxitem = (ZBX_DC_JMXITEM *)zbx_hashset_search(&config->jmxitems, &itemid)))
 		{
@@ -2745,6 +2826,13 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 			zbx_hashset_remove_direct(&config->httpitems, httpitem);
 		}
 
+		/* Zabbix agent (passive) items */
+		if (ITEM_TYPE_ZABBIX == item->type)
+		{
+			agent_hash = 0;
+			agent_type = ZBX_AGENT_ZABBIX;
+		}
+
 		/* it is crucial to update type specific (config->snmpitems, config->ipmiitems, etc.) hashsets before */
 		/* attempting to requeue an item because type specific properties are used to arrange items in queues */
 
@@ -2766,6 +2854,41 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 		}
 
 		DCupdate_item_queue(item, old_poller_type, old_nextcheck);
+
+		/* update interface status references */
+
+		old_agent_hash = (NULL == item->ifstatus ? 0 : item->ifstatus->agent_hash);
+
+		/* disable agent status tracking for not monitored items */
+		if (ITEM_STATUS_ACTIVE != item->status || HOST_STATUS_MONITORED != host->status)
+			agent_type = ZBX_AGENT_UNKNOWN;
+
+		if (0 != host->proxy_hostid)
+		{
+			/* set virtual agent interface for items monitored by proxy - maximum */
+			/* one interface per interface type (zabbix, snmp, ipmi, jxmx)        */
+			agent_interfaceid = 0;
+			agent_hash = ZBX_DEFAULT_STRING_HASH_ALGO(&agent_type, 1, 0);
+		}
+		else
+			agent_interfaceid = item->interfaceid;
+
+		if (old_agent_hash != agent_hash || agent_interfaceid != old_interfaceid)
+		{
+			if (NULL != item->ifstatus)
+				dc_host_ifstatus_release(item->hostid, item->ifstatus);
+
+			if (ZBX_AGENT_UNKNOWN != agent_type)
+			{
+				unsigned char	available;
+
+				available = (ZBX_DBSYNC_INIT == mode ? HOST_AVAILABLE_UNSET : HOST_AVAILABLE_UNKNOWN);
+				item->ifstatus = dc_host_ifstatus_add(item->hostid, agent_interfaceid, agent_type,
+						agent_hash, available);
+			}
+			else
+				item->ifstatus = NULL;
+		}
 	}
 
 	/* update dependent item vectors within master items */
@@ -2969,6 +3092,9 @@ static void	DCsync_items(zbx_dbsync_t *sync, int flags)
 			zbx_hashset_remove_direct(&config->httpitems, httpitem);
 		}
 
+		if (NULL != item->ifstatus)
+			dc_host_ifstatus_release(item->hostid, item->ifstatus);
+
 		/* items */
 
 		item_hk_local.hostid = item->hostid;
@@ -4669,7 +4795,7 @@ void	DCsync_configuration(unsigned char mode)
 
 	sec = zbx_time();
 	/* relies on hosts, proxies and interfaces, must be after DCsync_{hosts,interfaces}() */
-	DCsync_items(&items_sync, flags);
+	DCsync_items(&items_sync, flags, mode);
 	isec2 = zbx_time() - sec;
 
 	sec = zbx_time();
@@ -5434,6 +5560,8 @@ int	init_configuration_cache(char **error)
 			__config_mem_free_func);
 
 	CREATE_HASHSET(config->preprocops, 0);
+	CREATE_HASHSET(config->hosts_ifstatus, 0);
+	CREATE_HASHSET(config->hosts_availability, 0);
 
 	CREATE_HASHSET_EXT(config->items_hk, 100, __config_item_hk_hash, __config_item_hk_compare);
 	CREATE_HASHSET_EXT(config->hosts_h, 10, __config_host_h_hash, __config_host_h_compare);
@@ -5505,7 +5633,6 @@ int	init_configuration_cache(char **error)
 	config->status = (ZBX_DC_STATUS *)__config_mem_malloc_func(NULL, sizeof(ZBX_DC_STATUS));
 	config->status->last_update = 0;
 
-	config->availability_diff_ts = 0;
 	config->sync_ts = 0;
 	config->item_sync_ts = 0;
 	config->proxy_lastaccess_ts = time(NULL);
@@ -5586,23 +5713,7 @@ static void	DCget_host(DC_HOST *dst_host, const ZBX_DC_HOST *src_host)
 	dst_host->maintenance_status = src_host->maintenance_status;
 	dst_host->maintenance_type = src_host->maintenance_type;
 	dst_host->maintenance_from = src_host->maintenance_from;
-	dst_host->errors_from = src_host->errors_from;
-	dst_host->available = src_host->available;
-	dst_host->disable_until = src_host->disable_until;
-	dst_host->snmp_errors_from = src_host->snmp_errors_from;
-	dst_host->snmp_available = src_host->snmp_available;
-	dst_host->snmp_disable_until = src_host->snmp_disable_until;
-	dst_host->ipmi_errors_from = src_host->ipmi_errors_from;
-	dst_host->ipmi_available = src_host->ipmi_available;
-	dst_host->ipmi_disable_until = src_host->ipmi_disable_until;
-	dst_host->jmx_errors_from = src_host->jmx_errors_from;
-	dst_host->jmx_available = src_host->jmx_available;
-	dst_host->jmx_disable_until = src_host->jmx_disable_until;
 	dst_host->status = src_host->status;
-	strscpy(dst_host->error, src_host->error);
-	strscpy(dst_host->snmp_error, src_host->snmp_error);
-	strscpy(dst_host->ipmi_error, src_host->ipmi_error);
-	strscpy(dst_host->jmx_error, src_host->jmx_error);
 	dst_host->tls_connect = src_host->tls_connect;
 	dst_host->tls_accept = src_host->tls_accept;
 #if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
@@ -5903,6 +6014,16 @@ static void	DCget_item(DC_ITEM *dst_item, const ZBX_DC_ITEM *src_item)
 
 	dst_item->error = zbx_strdup(NULL, src_item->error);
 
+	if (NULL != src_item->ifstatus)
+	{
+		dst_item->agent.available = src_item->ifstatus->agent.available;
+		dst_item->agent.errors_from = src_item->ifstatus->agent.errors_from;
+		dst_item->agent.disable_until = src_item->ifstatus->agent.disable_until;
+		dst_item->agent.error = zbx_strdup(NULL, src_item->ifstatus->agent.error);
+	}
+	else
+		dst_item->agent.error = zbx_strdup(NULL, "");
+
 	switch (src_item->value_type)
 	{
 		case ITEM_VALUE_TYPE_FLOAT:
@@ -6163,6 +6284,7 @@ void	DCconfig_clean_items(DC_ITEM *items, int *errcodes, size_t num)
 
 		zbx_free(items[i].delay);
 		zbx_free(items[i].error);
+		zbx_free(items[i].agent.error);
 	}
 }
 
@@ -7374,7 +7496,9 @@ int	DCconfig_get_poller_items(unsigned char poller_type, DC_ITEM *items)
 		/* don't apply unreachable item/host throttling for prioritized items */
 		if (ZBX_QUEUE_PRIORITY_HIGH != dc_item->queue_priority)
 		{
-			if (0 == (disable_until = DCget_disable_until(dc_item, dc_host)))
+			disable_until = (NULL != dc_item->ifstatus ? dc_item->ifstatus->agent.disable_until : 0);
+
+			if (0 == disable_until)
 			{
 				/* move reachable items on reachable hosts to normal pollers */
 				if (ZBX_POLLER_TYPE_UNREACHABLE == poller_type &&
@@ -7397,7 +7521,7 @@ int	DCconfig_get_poller_items(unsigned char poller_type, DC_ITEM *items)
 					continue;
 				}
 
-				DCincrease_disable_until(dc_item, dc_host, now);
+				DCincrease_disable_until(dc_item, now);
 			}
 		}
 
@@ -7491,7 +7615,9 @@ int	DCconfig_get_ipmi_poller_items(int now, DC_ITEM *items, int items_num, int *
 		/* don't apply unreachable item/host throttling for prioritized items */
 		if (ZBX_QUEUE_PRIORITY_HIGH != dc_item->queue_priority)
 		{
-			if (0 != (disable_until = DCget_disable_until(dc_item, dc_host)))
+			disable_until = (NULL != dc_item->ifstatus ? dc_item->ifstatus->agent.disable_until : 0);
+
+			if (0 != disable_until)
 			{
 				if (disable_until > now)
 				{
@@ -7500,7 +7626,7 @@ int	DCconfig_get_ipmi_poller_items(int now, DC_ITEM *items, int items_num, int *
 					continue;
 				}
 
-				DCincrease_disable_until(dc_item, dc_host, now);
+				DCincrease_disable_until(dc_item, now);
 			}
 		}
 
